----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    09:28:01 09/17/2015 
-- Design Name: 
-- Module Name:    debouce - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: --  Provides a one-shot pulse from a non-clock input, with reset
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity debouce is
    Port ( clock : in  STD_LOGIC;
           reset : in  STD_LOGIC;
           D_IN : in  STD_LOGIC;
           D_OUT : out  STD_LOGIC);
end debouce;

architecture Behavioral of debouce is

signal Q1, Q2, Q3, Q4, Q5, Q6, Q7,Q8 : std_logic;

begin


process(clock)
begin
   if (clock'event and clock = '1') then
      if (reset = '1') then
         Q1 <= '0';
         Q2 <= '0';
         Q3 <= '0';
			Q4 <= '0';
			Q5 <= '0';
			Q6 <= '0';
			Q7 <= '0';
			Q8 <= '0';
      else
         Q1 <= D_IN;
         Q2 <= Q1;
         Q3 <= Q2;
			Q4 <= Q3;
			Q5 <= Q4;
			Q6 <= Q5;
			Q7 <= Q6;
			Q8 <= Q7;
      end if;
   end if;
end process;
 
D_OUT <= Q1 and Q2 and Q3 and Q4 and Q5 and Q6 and Q7 and Q8;


end Behavioral;

